import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;

class TEST{
    //Fuer Testzwecke darf auf den Graphen selbst zugegriffen werden.
    public GRAPH_MATRIX netzwerk;
    public ArrayList<String> zeilen = new ArrayList();
    
    //Konstruktor
    public TEST() {
        
        importData();

        System.out.println("Weg suchen:");
        netzwerk.wegeSuchen(3,17);        
    }
    
    public void importData() {
        //Datei auswaehlen
        /*
        JFileChooser chooser = new JFileChooser();
        int returnVal = chooser.showOpenDialog(null);
        String choosenFileName = "";
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            //System.out.println("You chose to open this file: " + chooser.getSelectedFile().getName());
            choosenFileName = chooser.getSelectedFile().getName();
        }
        */
        
        //Zeilenweise einlesen
        try {
            BufferedReader in = new BufferedReader(new FileReader("entfernungenDeutschland.csv"));
            String zeile = null;
            while ((zeile = in.readLine()) != null) {
                zeilen.add(zeile);
                System.out.println(zeile);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

        //Knoten aufbauen
        //Staedte stehen in der ersten Zeile
        String[] ersteZeile = zeilen.get(0).split(";");
        int dimension = ersteZeile.length;
        //Matrix erstellen
        netzwerk = new GRAPH_MATRIX(dimension);
        for (int i=0;i<dimension;i++) {
            netzwerk.knotenHinzufuegen(ersteZeile[i]);   
        }
        //netzwerk.knotenAusgeben();
        
        //Entfernungsmatrix aufbauen
        int zielIdx = -1;
        int startIndex = 0;
        int aktuelleEntfernung = 0;
        for (int i=1;i<dimension;i++) {//Fr jede eingelesene Zeile
            System.out.println(i);
            String[] naechsteZeile = zeilen.get(i).split(";",dimension);
            zielIdx++;
            for (int j=i;j<dimension;j++) {
                aktuelleEntfernung = 0;
                if (!naechsteZeile[j].isEmpty()) {
                    aktuelleEntfernung = Integer.parseInt(naechsteZeile[j]);
                }
                startIndex = j;
                netzwerk.kanteHinzufuegen(startIndex, zielIdx, aktuelleEntfernung);
            }
        }
        netzwerk.matrixAusgeben();
    }
}